#!/usr/bin/perl

require "./config.pm";
require "./siteup.pm";

print &TopOfPage();
print &JavaScripts_ls();
print &Header(qq{Edit file $P{'file'} at $P{'dir'}});

open(IN, "$P{'dir'}$DIRSEPARATOR$P{'file'}") || print &HoldError("can not open file $P{'dir'}$DIRSEPARATOR$P{'file'}");
binmode('IN'); grep ($filecontent .= $_, <IN>); close IN;

if (grep($P{'file'} =~ /\.$_$/i , split(/\,/, $HTMLFILES))) { $htmleditor = 1; }
$htmleditor = 1 if $P{'editor'} eq 'html';
$htmleditor = 0 if $P{'editor'} eq 'text';

if ($htmleditor)
{
	$filecontent_top = $1 if $filecontent =~ s/^(.*$STARTOFEDITABLECONTENT)//is;
	$filecontent_bot = $1 if $filecontent =~ s/($ENDOFEDITABLECONTENT.*)//is;
}

$filecontent =~ s'&'&#38;'g;
$filecontent =~ s'<'&#60;'g;
$filecontent =~ s'>'&#62;'g;

print qq{<form action="ls.cgi" method="post" name="editfileform" onsubmit="if (document.editfileform.menudir[1].checked) { SubmitBacisOperations(document.editfileform.menudir[1]) }">
<input type="hidden" name="act" value="savefile">
<input type="hidden" name="dir" value="$CURDIR">
Save <u>f</u>ile as:<br>
<input type="text" name="file" value="$P{'file'}" size="50" style="width:100%;" accesskey="f" title="Alt+F"><br>
<input type="radio" name="menudir" value="$CURDIR" checked> Save file to its current location<input type="radio" name="menudir" value=""> Save file to the directory selected in menu<br><br>};

if ($htmleditor)
{
	print qq{Document <u>h</u>eader:<br><textarea cols="60" rows="4" name="filecontent_top" wrap="off" style="width:100%" accesskey="h" title="Alt+H">$filecontent_top</textarea><br><br>};
	print &HtmlAreaInit();
}

print qq{Document content | }
.(($htmleditor)
?(qq{<a href="edit.cgi?dir=$CURDIRESCAPED&file=$P{'file'}&editor=text">switch to text editor</a>}.&HtmlAreaEditor('filecontent'))
:(qq{<a href="edit.cgi?dir=$CURDIRESCAPED&file=$P{'file'}&editor=html">switch to WYSIWYG editor</a>}))
.qq{<br><textarea cols="60" rows="25" name="filecontent" wrap="off" style="width:100%">$filecontent</textarea><br><br>};

if ($htmleditor)
{
	print qq{Document <u>b</u>ottom:<br><textarea cols="60" rows="4" name="filecontent_bot" wrap="off" style="width:100%" accesskey="b" title="Alt+B">$filecontent_bot</textarea><br><br>};
}

print qq{<p><table width="100%" border="0" cellspacing="0" cellpadding="0"><tr>
<td>
	<input type="submit" class="submit" value="Save changes" accesskey="s" title="Alt+S" onclick="document.editfileform.act.value='savefile'">
</td>
<td align="center">
	<input type="submit" class="submit" value="Save as template" accesskey="t" title="Alt+T" onclick="document.editfileform.act.value='newtemplate';">
</td>
<td align="right">
	<input type="submit" class="submit" value="Delete file" accesskey="d" title="Alt+D" onclick="document.editfileform.act.value='deletefiles'; document.editfileform.file.value='$P{'file'}'">
</td>
</tr></table></p>
</form>};

print &BottomOfPage();

