#!/usr/bin/perl

require "./config.pm";
require "./siteup.pm";
print &TopOfPage();
print &JavaScripts_ls();

require "./actions.pm";

($dirdate) = &FileInfo($CURDIR); $qty = 0; $filessize = 0;
opendir (DIR, $CURDIR);
while ($file = readdir(DIR)) { (-d "$CURDIR$DIRSEPARATOR$file") ? do{push (@dirs, "$file") if ($file ne '.' and $file ne '..' and !grep($file eq $_, split(/\,/, "$IGNOREDIRS")))} : push (@files, $file) }
@dirs = sort @dirs;
@files = sort @files;
$i = 6;
$bgcolor = '#F9F9F9';
foreach $file(@dirs, @files)
{
	if (grep($file =~ /\.$_$/i , split(/\,/, "$IGNOREFILES"))) { next }
	($filedate, $filesize, $fileurl, $filemode, $slink) = &FileInfo("$CURDIR$DIRSEPARATOR$file");
	$filessize += $filesize;
	$slink = qq{ <span title="symlink for $slink">*</span>} if $slink;
	++$qty;
	if (-d "$CURDIR$DIRSEPARATOR$file")
	{ $filesize = 'DIR'; $filename = qq{[<b><a href="ls.cgi?act=cd&dir=$CURDIR$DIRSEPARATOR$file" title="change directory">$file</a></b>]}; }
	else
	{
		if (grep($file =~ /\.$_$/i, split(/\,/, "$TEXTFILES,$HTMLFILES"))) { $filename = qq{<a href="edit.cgi?dir=$CURDIR&file=$file" title="click to edit file">$file</a>} }
		elsif (grep($file =~ /\.$_$/i , split(/\,/, "$ARCHFILES"))) { $filename = qq{<a href="#" onclick="if (confirm('Unpack file $file to the directory '+unescape(top.frames['menu'].curdir)+' selected in menu?')) { sync = false; self.location='ls.cgi?act=unpack&dir=$CURDIRESCAPED&menudir='+top.frames['menu'].curdir+'&file=$file' }; return false;" title="click to unpack file to the directory selected in menu">$file</a>} }
		else { $filename = $file; }
		$filesize = qq{<a href="download.cgi?file=$file&dir=$CURDIRESCAPED" title="download file">$filesize</a>};
		$filemode = qq{<a href="#" onclick="options=prompt('input command line options if required',''); if (options){options=escape(options)}else{options=''}; self.location='execute.cgi?file=$file&dir=$CURDIRESCAPED&options='+options; return false;" title="execute file">$filemode</a>} if ($filemode =~ '7');
	}
	($bgcolor eq '#F9F9F9')?($bgcolor = '#FFFFFF'):($bgcolor = '#F9F9F9');
	$files .= qq{<tr bgcolor="$bgcolor" onmouseover="this.bgColor='#E8E8E8';" onmouseout="this.bgColor='$bgcolor';">
		<td><input type="checkbox" name="file" value="$file" title="select for action\nor double click to copy file to file with $BAKEXT extension" ondblclick="self.location='ls.cgi?menudir=$CURDIRESCAPED&dir=$CURDIRESCAPED&act=copyfiles&file=$file&$file=$file$BAKEXT'" onclick="filelistform.elements[$i].disabled = !filelistform.elements[$i].disabled; if (!filelistform.elements[$i].disabled) { filelistform.elements[$i].focus() }"></td>
		<td title="double click to open \n$fileurl" ondblclick="window.open('$fileurl','preview')"><pre>$filename$slink</pre></td>
		<td><input type="text" size="20" name="$file" class="linput" title="double click to insert file name" disabled ondblclick="filelistform.elements[$i].value = filelistform.elements[$i-1].value + '$BAKEXT'"></td>
		<td nowrap>$filedate</td>
		<td>$filemode</td>
		<td>$filesize</td>
	</tr>};
	$i += 2;
}
closedir(DIR);
print &Header(qq{Selected directory $CURDIR | <a href="#" onclick="Synchronize(top.frames['menu'].curdir, false); return false;" title="Click to synchronize current directory with directory selected in menu">synchronize</a>});
print qq{<p><table width="100%" border="0" cellspacing="0" cellpadding="0"><tr><td nowrap>}
.(($DOCUMENT_ROOT ne $CURDIR)
?(qq{[ <a href="ls.cgi?act=cd&dir=$UPDIR">go up</a> ]})
:('&nbsp;'))
.qq{<td nowrap align="center"><form action="search.cgi">
		<input type="hidden" name="dir" value="$CURDIR">
		&nbsp;f<u>i</u>nd files: <input type="text" name="mask" class="linput" size="20" accesskey="i" title="Alt+I / use Perl regular expression">
		<input type="Submit" value="search" class="linput">&nbsp;
		</form></td>
	<form action="ls.cgi" method="post" name="filelistform" onsubmit="SubmitBacisOperations(document.filelistform.menudir)">
	<input type="hidden" name="dir" value="$CURDIR">
	<input type="hidden" name="menudir" value="$CURDIR">
	</td><td align="right" valign="top" nowrap>select by mask: <input type="text" name="mask" value="$P{'mask'}" class="linput" size="15" accesskey="*" title="Alt+*"> <input type="button" value="select" class="linput" onclick="SelectByMask(document.filelistform.mask.value)" accesskey="/" title="Alt+\/"></td></tr></table></p>}
.(($files)
?(qq{<table width="100%" border="0" cellspacing="0" cellpadding="0" bgcolor="#c0c0c0"><tr><td>
	<table width="100%" border="0" cellspacing="1" cellpadding="2">
	<tr bgcolor="#F9F9F9">
		<td><input title="invert selection" type="checkbox" onclick="for (var i=0;i<filelistform.elements.length;i++) { var z=filelistform.elements[i]; var zz=filelistform.elements[i+1]; if (z.name == 'file') { z.checked = !z.checked; zz.disabled = !zz.disabled; } }"></td>
		<td width="100%"><b>File name</b></td>
		<td nowrap><b>New name</b></td>
		<td nowrap><b>Last modified</b></td>
		<td><b>Mode</b></td>
		<td><b>Size</b></td>
	</tr>	
	$files
</table></td></tr></table>
<p>$filessize bytes at $qty files and directories | directory created at $dirdate</p>
<table width="100%" border="0" cellspacing="0" cellpadding="0"><tr>
<td valign="top" width="50%">
	<input type="radio" name="act" value="deletefiles" onclick="CheckFileListForm('deletefiles')" accesskey="d" title="Alt+D"> <u>D</u>elete selected files and directories<br>
	<input type="radio" name="act" value="copyfiles" onclick="CheckFileListForm('copyfiles')" accesskey="c" title="Alt+C"> <u>C</u>opy selected files and directories<br>
	<input type="checkbox" name="act" value="renamefiles" onclick="CheckFileListForm('renamefiles')" accesskey="r" title="Alt+R"> <u>R</u>ename or move selected files and directories<br>
	<input type="checkbox" name="act" value="chmodfiles" onclick="CheckFileListForm('chmodfiles')" accesskey="h" title="Alt+H"> C<u>h</u>mod files to: <input type="text" name="chmodfiles" value="$CHMODFILES" size="3" disabled class="linput"> directories to <input type="text" name="chmoddirs" value="$CHMODDIRS" size="3" disabled class="linput">
</td>
<td>&nbsp;</td>
<td valign="top" width="50%">
	<input type="radio" name="act" value="emailfiles" onclick="CheckFileListForm('emailfiles')" accesskey="m" title="Alt+M"> Send selected files by e<u>m</u>ail<br>
	<input type="radio" name="act" value="packfiles" onclick="CheckFileListForm('packfiles')" accesskey="a" title="Alt+A"> <u>A</u>rchive selected files and directories to: <input type="text" name="archivename" size="10" disabled title="type here file name of archive" class="linput"><br>
	<input type="radio" name="act" value="ftpfiles" onclick="CheckFileListForm('ftpfiles')" accesskey="u" title="Alt+U"> <u>U</u>pload selected files and directories to FTP<br>
	<input type="radio" name="act" value="symlinkfiles" onclick="CheckFileListForm('symlinkfiles')" accesskey="y" title="Alt+Y"> Create s<u>y</u>mbolic links
</td>
</tr>
<tr>
	<td><br><input type="submit" class="submit" name="submit" value="First select action" disabled accesskey="o" title="Alt+O"></td>
	<td>&nbsp;</td>
	<td align="right"><br><input type="Reset" class="submit" value="Reset all changes" onclick="CheckFileListForm('reset')"></td>
</tr></table>})
:(qq{</form>
	<p><blockquote>No files found</blockquote></p>
	<p><form action="ls.cgi" method="post">
	<input type="hidden" name="act" value="deletefiles">
	<input type="hidden" name="dir" value="$UPDIR">
	<input type="hidden" name="file" value="$FILEDIR">
	<input type="submit" class="submit" value="Delete empty directory">
}))
.'</form></p>';

$template = '';
opendir (DIR, ".$DIRSEPARATOR".'templates');
while ($file = readdir(DIR))
{
	$template .= qq{<option value="$file"}.(($file eq $NEWFILETEMPLATE)?(' selected'):('')).qq{>$file} if (!-d ".$DIRSEPARATOR".'templates'."$file" and $file ne '.' and $file ne '..')
}

print &Header(qq{Select action | <a href="#" onclick="MoreFields(fields); return false;" title="only for MS Internet Explorer">more fields</a>});
print qq{<form action="ls.cgi" method="post" enctype="multipart/form-data">
<div id="fields">
<table width="100%" border="0" cellspacing="0" cellpadding="0"><tr>
<td>Create direc<u>t</u>ory:<br><input type="text" name="dirname" size="17" accesskey="t" title="Alt+T" style="width:100%"></td>
<td>&nbsp;</td>
<td>Create <u>f</u>ile:<br><input type="text" name="file" size="17" accesskey="f" title="Alt+F" style="width:100%"></td>
<td>&nbsp;</td>
<td>U<u>p</u>load file:<br><input type="file" name="uploadfile1" size="17" accesskey="p" title="Alt+P" style="width:100%"></td>
</tr></table>
</div>
<p><table width="100%" border="0" cellspacing="0" cellpadding="0"><tr>
<td>Use this template to create new files: <select name="template" style="width:30%">$template</select></td>
<td>&nbsp;</td>
<td width="1"><input type="submit" value="Submit" class="submit"></td>
</tr></table></p>
<input type="hidden" name="dir" value="$CURDIR">
<input type="hidden" name="act" value="createnew">
</form>};

print &Header('E<u>x</u>ecute command or file');
print qq{<form action="execute.cgi">
<input type="hidden" name="dir" value="$CURDIR">
<input type="hidden" name="act" value="executecommand">
<p>Type the name of a program or command and command line options and switches:<br><table width="100%" border="0" cellspacing="0" cellpadding="0"><tr>
<td width="100%"><input type="text" name="file" value="" accesskey="x" title="Alt+X" style="width:100%"></td>
<td>&nbsp;</td>
<td valign="bottom"><input type="submit" value="Execute" class="submit"></td>
</tr></table></p>
</form>};

print &BottomOfPage();

