#!/usr/bin/perl

require "./config.pm";
require "./siteup.pm";

print &TopOfPage();
print &JavaScripts_ls();
print &Header(qq{Search files by mask $P{'mask'} from the directory $P{'dir'}});

@dirs = &FindDirs($P{'dir'});
$bgcolor = '#F9F9F9';
foreach $dir(@dirs)
{
	opendir (DIR, $dir);
	while ($file = readdir(DIR))
	{
		if (!-d "$dir$DIRSEPARATOR$file" and eval(q{$file =~ /$P{'mask'}/i}) and $file ne '.' and $file ne '..')
		{
			($filedate, $filesize, $fileurl, $filemode, $slink) = &FileInfo("$dir$DIRSEPARATOR$file");
			$slink = qq{ <span title="symlink to $slink">*</span>} if $slink;
			$direscaped = &EscapeChars($dir);
			if (grep($file =~ /\.$_$/i , split(/\,/, "$TEXTFILES,$HTMLFILES"))) { $filename = qq{<a href="edit.cgi?dir=$dir&file=$file" title="click to edit file">$file</a>} }
			elsif (grep($file =~ /\.$_$/i , split(/\,/, "$ARCHFILES"))) { $filename = qq{<a href="#" onclick="if (confirm('Unpack file $file to the directory '+unescape(top.frames['menu'].curdir)+' selected in menu?')) { sync = false; self.location='ls.cgi?act=unpack&dir=$direscaped&menudir='+top.frames['menu'].curdir+'&file=$file' }; return false;" title="click to unpack file to the directory selected in menu">$file</a>} }
			else { $filename = $file; }
			$filesize = qq{<a href="download.cgi?file=$file&dir=$dir" title="download file">$filesize</a>};
			$filemode = qq{<a href="#" onclick="options=prompt('input command line options if required',''); if (options){options=escape(options)}else{options=''}; self.location='execute.cgi?file=$file&dir=$direscaped&options='+options; return false;" title="execute file">$filemode</a>} if ($filemode =~ '7');
			($bgcolor eq '#F9F9F9')?($bgcolor = '#FFFFFF'):($bgcolor = '#F9F9F9');
			$files .= qq{<tr bgcolor="$bgcolor" onmouseover="this.bgColor='#E8E8E8';" onmouseout="this.bgColor='$bgcolor';">
			<td title="double click to open \n$fileurl" ondblclick="window.open('$fileurl','preview')"><pre>$filename$slink</pre></td>
			<td nowrap>$filedate</td>
			<td>$filemode</td>
			<td>$filesize</td>
			</tr>};
		}
	}
	closedir(DIR);
	print qq{<p><table width="100%" border="0" cellspacing="0" cellpadding="0" bgcolor="#c0c0c0"><tr><td>
	<table width="100%" border="0" cellspacing="1" cellpadding="2">
	<tr bgcolor="#E9E9E9"><td  colspan="4"><pre>[ <b><a href="ls.cgi?act=cd&dir=$dir" title="change directory">$dir</a></b> ]</pre></td></tr>}
	.(($files)
	?(qq{<tr bgcolor="#F9F9F9">
		<td width="100%"><b>File name</b></td>
		<td nowrap><b>Last modified</b></td>
		<td><b>Mode</b></td>
		<td><b>Size</b></td>
		</tr>$files})
	:('<tr bgcolor="#FFFFFF"><td colspan="4">&nbsp;No files found</td></tr>'))
	.qq{</table></td></tr></table></p>} if $files or eval(q{$dir =~ /$P{'mask'}/i});
	$files = '';
}

print &Header('Search again');
print qq{<form action="search.cgi">
<input type="hidden" name="dir" value="$CURDIR">
<p><table width="100%" border="0" cellspacing="0" cellpadding="0"><tr>
<td width="100%">Type a file mask:<br><input type="text" name="mask" style="width:100%" value="$P{'mask'}"></td>
<td>&nbsp;</td>
<td valign="bottom"><input type="submit" class="submit" value="Search again"></td>
</tr></table></p>
</form>};

print &BottomOfPage();


sub FindDirs
{
	my ($dir) = @_;
	my ($file, @dirs) = ();
	push (@dirs, $dir);
	local *DIR;
	opendir (DIR, $dir);
	while ($file = readdir(DIR))
	{
		push (@dirs, &FindDirs("$dir$DIRSEPARATOR$file")) if ((-d "$dir$DIRSEPARATOR$file") and $file ne '.' and $file ne '..');
	}
	closedir(DIR);
	return @dirs;
}
